#include <features.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <net/if.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <string.h>
#include <linux/if_ether.h>
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include "subs.h"

#define BUFSIZE 1516


void reset_devices()
{
	int sd;
	if((sd = socket(PF_INET, SOCK_STREAM, 0))<0)
	{
		perror("socket");
		exit(-1);
	}
	initialize("tap0", sd, 0);
	initialize("eth0", sd, 0);
	close(sd);
#ifdef VERBOSE
	printf("Exiting for user request...\n");
#endif
	exit(0);
}


int main(int argc , char **argv)
{
	struct ethhdr *packet;
	struct sockaddr_ll sock_ether;
	
	unsigned char buf[BUFSIZE];


	int bytes_received, eth_index;
	int sd, fd;
	fd_set afds,rfds;

	signal(SIGINT, reset_devices);
	signal(SIGQUIT, reset_devices);

	FD_ZERO(&afds);
	
	if((fd = open("/dev/tap0", O_RDWR))<0)
	{
		perror("open");
		return -1;
	}

	if((sd=socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL)))<0)
	{
		perror("socket");
		return -1;
	}
	if(initialize("tap0", sd, 1)<0)
	{
		return -1;
	}
	if((eth_index = initialize("eth0", sd, 1))<0)
	{
		return -1;
	}
	bzero(&sock_ether, sizeof(sock_ether));
	sock_ether.sll_family = AF_PACKET;
	sock_ether.sll_protocol = htons(ETH_P_ALL);
	sock_ether.sll_ifindex = eth_index;
	if(bind(sd, (struct sockaddr *)(&sock_ether), sizeof(sock_ether))<0)
	{
		perror("bind");
		return -1;
	}

	FD_SET (fd, &afds);
	FD_SET (sd, &afds);

	while(1)
	{
		bcopy( (char*) &afds, (char*) &rfds, sizeof(rfds) ) ;
		if ((select(FOPEN_MAX, &rfds, NULL, NULL, NULL)) < 0)
		{
			perror ("select");
			return -1;
		}
		if(FD_ISSET(fd, &rfds))
		{
			if((bytes_received=read(fd, buf, sizeof buf))<0)
			{
				perror("read from ethertap failed");
				return -1;
			}
			bytes_received-=2;
			packet = (struct ethhdr *)(buf+2);
			if(send_eth(sd, packet, "eth0", bytes_received)<0)
			{
				return -1;
			}
		}
		if(FD_ISSET(sd, &rfds))
		{
			if((bytes_received=read(sd, buf, sizeof buf))<0)
			{
				perror("read from ethernet failed");
				return -1;
			}
			packet = (struct ethhdr *)buf;
			if((send_tap( fd, packet, "tap0", bytes_received ))<0)
			{
				return -1;
			}
		}
	}
}
